// create a json file
import fs from 'fs';
import path from 'path';
import { exec } from 'child_process';

// read the file and return as json
export async function readJsonFile(filename) {
    const filePath = path.join(process.cwd(), filename);
    const fileContents = fs.readFileSync(filePath, 'utf8');
    return JSON.parse(fileContents);
}

// create a function to write to file
export async function writeJsonFile(filename, content) {
    const filePath = path.join(process.cwd(), filename);
    fs.writeFileSync(filePath, JSON.stringify(content, null, 2));
}

// run a command
export async function runCommand(command) {
    return new Promise((resolve, reject) => {
        exec(command, (error, stdout, stderr) => {
            if (error) {
                reject(error);
                return;
            }
            resolve(stdout.trim());
        });
    });
}

const json = await readJsonFile('package.json');

delete json.funding;
delete json.ethereum;
delete json.scripts;
delete json.sideEffects;
delete json.tarballHash;
delete json.repository;

json.name = 'pkp-either-signer';
json.keywords.push('Lit Protocol');
json.keywords.push('PKP');
json.author = `${json.author} & modified by Anson (Lit Protocol)`;
json.description = `PKP Signer for ethers.`;

await writeJsonFile('pkp-package.json', json);

await runCommand('mv package.json package.json.bak');
await runCommand('mv pkp-package.json package.json');
await runCommand('npm publish --access public');